# -*- coding: utf-8 -*-
"""Script for gathering links and prepare it for next usage

   LinksMiner is an extension for program linkssorter.
   It is highly depend on LinsSorter script so it can be used separately 
"""

from tools import logger
# import tools.globals as G  # Globals of linkssorter
import lmglobals as GLM      # Globals of extension
from linkscollector import buildLinksStructure, buildGroupsStructure, collectBrowseDirs, collectDataFiles


__author__    = "Filip Vaculik (mintaka@post.cz)"
__version__   = "$Revision: 0.1.0 $"
__date__      = "$Date: 2007/04/13 04:15:20 $"
__copyright__ = "Copyright (c) 2007 Filip Vaculik"
__license__   = "GPL"

log = logger.getLogger()
#log.setLevel(10)

def getLinks():
    browseDirs  = collectBrowseDirs()
    linksFiles  = collectDataFiles(browseDirs, GLM.linksXMLfiles)
    return buildLinksStructure(linksFiles)
    
def getGroups():
    browseDirs  = collectBrowseDirs()
    groupsFiles = collectDataFiles(browseDirs, GLM.groupsXMLfiles)
    return buildGroupsStructure(groupsFiles)


#log.info("EXTENSION LinkMiner started")

    
# links.printNamesOfLinks()
# groups.printNames()
#log.info("EXTENSION LinkMiner End")