# -*- coding: utf-8 -*-

"""
Test modul for modul  osutils 


"""
from idlelib.IOBinding import filesystemencoding

import os
import osutils
from nose import with_setup

mopdirs =['./mopdir/mopdir1a/mopdir2p/mopdir3x',
          './mopdir/mopdir1a/mopdir2q',
          './mopdir/mopdir1a/mopdir2r',
          './mopdir/mopdir1b/mopdir2s',
          './mopdir/mopdir1c'
         ]

mopfiles=['./mopdir/mopfile0a.xml',
          './mopdir/mopfile0b.xml',
          './mopdir//mopdir1a/mopfile1a.xml',
          './mopdir//mopdir1a/mopfile1b.xml',
          './mopdir//mopdir1b/mopfile1c.xml',
          './mopdir/mopdir1a/mopdir2r/mopfile2a.xml',
          './mopdir/mopdir1a/mopdir2p/mopdir3x/mopfile3a.xml',
         ]

def setup_func():
    os.chdir('./tmp')
    print "SETUP"
    for dir in mopdirs:
        try:
            os.makedirs(dir)
        except OSError, e:
            print ("Could not create directory %s" % (e))
    
    for fil in mopfiles:
        try:
            f = file(fil, 'a')         
            f.close()
        except OSError, e:
            print ("Could not create directory %s" % (e))
    
            

def teardown_func():
    print "TEARDOWN"
    #alterntivly use shutil.rmtree('mopdir', ignore_errors=1)
    for fil in mopfiles: os.remove(fil)
    for dir in mopdirs: os.removedirs(dir)
    

@with_setup(setup_func, None)
def test_listDirs():
    """Test if listDirs return right output"""
    print "TESTING... listDirs"
    val = ['.\\mopdir\\mopdir1a', '.\\mopdir\\mopdir1b', '.\\mopdir\\mopdir1c']
    ret = osutils.listDirs('./mopdir')
    assert val == ret, 'Output not equal \n\t %s \n\t %s' % (val, ret) 

def test_listDirsMulti():
    """Test if listDirsMulti return right output"""
    print "TESTING... listDirsMulti"      
    val = ['.\\mopdir\\mopdir1a', '.\\mopdir\\mopdir1b', '.\\mopdir\\mopdir1c', '.\\mopdir\\mopdir1a\\mopdir2p\\mopdir3x']
    ret = osutils.listDirsMulti(['.\\mopdir','.\\mopdir\\mopdir1a\\mopdir2p'])
    assert val == ret, 'Output not equal \n\t %s \n\t %s' % (val, ret)

    
def test_listDirsOnlevel():
    print "TESTING... listDirsOnlevel"
    val = ['.\\mopdir\\mopdir1a', '.\\mopdir\\mopdir1b', '.\\mopdir\\mopdir1c']
    ret = osutils.listDirsOnlevel(['.\\mopdir'], 1)
    assert val == ret, 'Output not equal \n\t %s \n\t %s' % (val, ret) 
    val = ['.\\mopdir\\mopdir1a\\mopdir2p\\mopdir3x']
    ret = osutils.listDirsOnlevel(['.\\mopdir'], 3)
    assert val == ret, 'Output not equal  \n\t %s \n\t %s' % (val, ret)

def test_listFilesOnLevel(): 
    print "TESTING... listFilesOnLevel"
    #search for file on level 1
    val = ['.\\mopdir\\mopfile0a.xml', '.\\mopdir\\mopfile0b.xml']
    ret = osutils.listFilesOnLevel(['.\\mopdir'], ['*.xml'], 0)
    val.sort()
    ret.sort()
    assert val == ret, 'Output not equal  \n\t %s \n\t %s' % (val, ret)
    
    #search for files on level 3
    val = ['.\\mopdir\\mopdir1a\\mopdir2p\\mopdir3x\\mopfile3a.xml']
    ret = osutils.listFilesOnLevel(['.\\mopdir'], ['*.xml'], 3)
    assert val == ret, 'Output not equal  \n\t %s \n\t %s' % (val, ret)
    
    #search for file on level 1 multiple mask
    vals = ['.\\mopdir\\mopfile0a.xml', '.\\mopdir\\mopfile0b.xml']
    rets = osutils.listFilesOnLevel(['.\\mopdir'], ['*.xml', '*.*'], 0)
    val.sort()
    ret.sort()
    assert vals[0] in rets, 'Output not contain  \n\t %s \n\t in \n\t %s' % (vals[0], rets)
    assert vals[1] in rets, 'Output not contain  \n\t %s \n\t in \n\t %s' % (vals[0], rets)
      

@with_setup(None, teardown_func)
def test_clenUp():
    """just run teardown_func
    """
    pass


    








